//    --   zz_start,    
// 
//   (  -  )/( )

extern double ZZStepPips = 15;

#define ndelta 10

int ZZcounts[5*ndelta];

datetime timestart;
double point4;

void init() {
   ArrayInitialize(ZZcounts,0);
   timestart = TimeCurrent();
   if (Digits < 4) {
      point4 = 0.01;
   } else {
      point4 = 0.0001;
   }   
}

void deinit() {
   double sum  = 0;
   int indmax = -1;
   for (int i = 5*ndelta-1; i >=0; i--) {
      if (indmax < 0 && ZZcounts[i] > 0) indmax = i;
      sum = sum + ZZcounts[i];
      if (ZZcounts[i] > 0) Print(i,"   ",ZZcounts[i]);
   }

   string FileName = WindowExpertName()+ " " + Symbol() + ".txt";
   int handle=FileOpen(FileName,FILE_CSV|FILE_READ|FILE_WRITE," ");
   if (handle < 0) {
      Print("Error reading/creating file ",FileName);
   } else {
      if (!FileSeek(handle, 0, SEEK_END)) Print("FileSeek ( " + FileName + ", 0, SEEK_END ) - Error #", GetLastError());
      else {
         FileWrite(handle," ");
         FileWrite(handle,"=======================================================================================");
         FileWrite(handle,"Time period: "+TimeToStr(timestart,TIME_DATE)+" -- "+TimeToStr(TimeCurrent(),TIME_DATE));
         FileWrite(handle,"ZZStep = "+ZZStepPips+" pt");
         FileWrite(handle,"nZZ = "+nZZ);
         if (nZZ>0) FileWrite(handle,"Average overshot = "+DoubleToStr(avovershot/nZZ,4));
         double cumsum = 0;
         for (i = indmax; i >=0; i--) {
            cumsum = cumsum + ZZcounts[i]/sum;
            FileWrite(handle,DoubleToStr((i+0.5)/(ndelta*1.0),2)+" \t "+DoubleToStr(ZZcounts[i]/sum,5)+" \t "+DoubleToStr(cumsum,5));
         }        
         FileWrite(handle,"=======================================================================================");

         Print(" ");
         Print("=======================================================================================");
         Print("Time period: "+TimeToStr(timestart,TIME_DATE)+" -- "+TimeToStr(TimeCurrent(),TIME_DATE));
         Print("ZZStep = "+ZZStepPips+" pt");
         Print("nZZ = "+nZZ);
         if (nZZ>0) Print("Average overshot = "+DoubleToStr(avovershot/nZZ,4));
         cumsum = 0;
         for (i = indmax; i >=0; i--) {
            cumsum = cumsum + ZZcounts[i]/sum;
            Print(DoubleToStr((i+0.5)/(ndelta*1.0),2)+" \t "+DoubleToStr(ZZcounts[i]/sum,5)+" \t "+DoubleToStr(cumsum,5));
         }        
         Print("=======================================================================================");
      }
      FileClose(handle);
   }
}


double prev;
bool bUp;
double ZZStep;
double zz_start;

void start() {
   ZZStep = ZZStepPips*point4;
   int res = ZZevent(ZZStep,bUp,prev,Bid,Bid,TimeCurrent());
}


//   :
#define NoChange  0
#define SwingUp 1
#define NextUp 2
#define SwingDn -1
#define NextDn -2


//
//--
//
int ZZevent(double ZZStep0, bool& bUp0, double& prev0, double high, double low, int time) {
   int iZZ = NoChange;
   if (bUp0) {  //   
         //   
      if (high >= prev0) {
         AddZZvertex(0,high,time);
         prev0 = high;
         iZZ = NextUp;         
      } else if (low <= prev0-ZZStep0) { //  
         bUp0=false;
         AddZZvertex(1,low,time);
         prev0 = low;
         iZZ = SwingDn;         
         zz_start = low;  
      }
   } else {  //   
         //   
      if (low <= prev0) {
         AddZZvertex(0,low,time);
         prev0 = low;
         iZZ = NextDn;         
      } else if (high >= prev0+ZZStep0) {  //  
         bUp0=true;
         AddZZvertex(1,high,time);
         prev0 = high;
         iZZ = SwingUp;         
         zz_start = high;  
      }
   }
   return(iZZ);
}

#define nzzmax0 100    // .    

double ZZPrice[nzzmax0];
datetime ZZTime[nzzmax0];

int nZZ = 0;
double avovershot = 0;

//
//--
//
void AddZZvertex(int shift, double zzp, datetime zzt) {
   if (shift > 0) {
      for (int j = nzzmax0-1; j > 0; j--) {
         ZZPrice[j] = ZZPrice[j-1];
         ZZTime[j] = ZZTime[j-1];
      }
   }
   ZZPrice[0] = zzp;
   ZZTime[0] = zzt;

   if (shift > 0 && ZZPrice[1] > 0 && ZZPrice[2] > 0 && zz_start > 0) {
      nZZ++;
//    double overshot = (MathAbs(ZZPrice[1]-ZZPrice[2])-ZZStep)/ZZStep;
//      double overshot = MathAbs(ZZPrice[1]-zz_start)/MathAbs(ZZPrice[2]-zz_start);
      double overshot = MathAbs(ZZPrice[1]-zz_start)/ZZStep;
      avovershot = avovershot + overshot;
      int ind = MathMin(5*ndelta-1,MathFloor(overshot*ndelta));
      ZZcounts[ind]++;   
   }
}
 
double OnTester( void ) {
  if (nZZ > 0) return(avovershot/nZZ);
     else return(0);
}